#include "mainwidget.h"
#include "ui_mainwidget.h"

MainWidget::MainWidget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::MainWidget)
{
    ui->setupUi(this);

    //создание объекта QRegexpHighlighter
    highlighter = new QRegexpHighliter(this);
    //связывание с объектом документа
    highlighter->setDocument(ui->teSource->document());
}

MainWidget::~MainWidget()
{
    delete ui;
}

bool MainWidget::checkRegExp(QRegExp rx)
{
    //проверка регулярного выражения на корректность:
    //корректный синтаксис шаблона, непустой шаблон, пустая строка не удовлетворяет регулярному выражению
    if (rx.isValid() && !rx.isEmpty() && !rx.exactMatch("")){
        return true;
    }
    else {
        //вывод информационного окна
        QMessageBox::information(this, "", trUtf8("Некорректный шаблон регулярного выражения!"));
        return false;
    }
}

void MainWidget::on_btnFind_clicked()
{
    //создание регулярного выражения с заданным шаблоном
    QRegExp rx(ui->edPattern->text());
    //проверка на корректность
    if (!checkRegExp(rx))
        return;
    //установка свойства жадости
    rx.setMinimal(!ui->chbGreed->isChecked());
    //отчиска виджета списка
    ui->lwResults->clear();

    //позиция курсора поиска
    int pos = 0;
    //цикл поиска подстрок, удовлетворяющих шаблону регулярного выражения
    while ((pos = rx.indexIn(ui->teSource->toPlainText(), pos)) != -1){
        //добавление найденой подстроки в виджет списка
        ui->lwResults->addItem(rx.cap(0));        
        pos += rx.matchedLength();
    }
}

void MainWidget::on_btnReplace_clicked()
{
    //создание регулярного выражения
    QRegExp rx(ui->edPattern->text());
    //проверка корректности регулярного выражения
    if (!checkRegExp(rx))
        return;

    //установка свойства жадности
    rx.setMinimal(!ui->chbGreed->isChecked());
    //получение результата замены и отображение его
    ui->teResultText->setPlainText(ui->teSource->toPlainText().replace(rx, ui->edReplacePattern->text()));
}

void MainWidget::on_edPattern_textChanged(const QString &arg1)
{
    //обновление шаблона объекта подсветки
    highlighter->setPattern(arg1);
    //вызов переподсвечивания
    highlighter->rehighlight();
}
