#ifndef MAINWIDGET_H
#define MAINWIDGET_H

#include <QWidget>
#include <QRegExp>
#include <QMessageBox>
#include "qregexphighliter.h"

namespace Ui {
class MainWidget;
}

class MainWidget : public QWidget
{
    Q_OBJECT
    
public:
    explicit MainWidget(QWidget *parent = 0);
    ~MainWidget();
    
private slots:
    //слот обработки сигнала нажатия кнопки "Искать"
    void on_btnFind_clicked();
    //слот обработки сигнала нажатия кнопки "Заменить"
    void on_btnReplace_clicked();
    //слот обработки сигнала изменения шаблона
    void on_edPattern_textChanged(const QString &arg1);

private:
    Ui::MainWidget *ui;
    //объект подсветки
    QRegexpHighliter* highlighter;
    //метод проверки регулярного выражения на корректность
    bool checkRegExp(QRegExp rx);
};

#endif // MAINWIDGET_H
