#include "qregexphighliter.h"
#include <QTextCharFormat>

QRegexpHighliter::QRegexpHighliter(QObject *parent) :
    QSyntaxHighlighter(parent)
{
}

void QRegexpHighliter::highlightBlock(const QString &text)
{
    //создание объекта текстового формата
    QTextCharFormat format;

    //создание регулярного выражения и проверка на корректность
    QRegExp rx(pattern);
    if (pattern.isEmpty()||!rx.isValid()||rx.exactMatch(""))
    {
        //очистка подсветки всего текста
        setFormat(0, text.length(), format);
        return;
    }

    //настройка формата подсветки
    format.setBackground(Qt::yellow);
    format.setFontPointSize(12);

    int index = rx.indexIn(text);
    //цикл поиска подстрок
    while (index > 0){
        int length = rx.matchedLength();
        //применение формата на найденную подстроку
        setFormat(index, length, format);
        index = rx.indexIn(text, index + length);
    }
}
